Description

The did_you_mean gem has been a bundled gem for over 3 years now and I think it's time to promote it to a standard library. There

are two main issues in the current structure:

A number of implementations, including optparse.rb, rake, and rails, now take advantage of the gem's spell checker, but it's

awkward to have to check the existence of the DidYouMean::SpellChecker constant.

there are some problems with regard to bundler + did_you_mean because of did_you_mean being a bundled gem. Since the

vendored version of thor inside bundler and ruby itself explicitly requires did_you_mean, it can become difficult to load it when

using Bundler.setup. See this issue: https://github.com/yuki24/did_you_mean/issues/117#issuecomment-482733159 for more

details.

I would like to promote the gem up to a standard library and make it always available, so we can always reliably require it whenever

we want to.

A patch could be found here: https://github.com/ruby/ruby/pull/2689

Related issues:

Related to Ruby - Bug #16427: Revert did_you_mean promotion to default gem. Rejected

Related to Ruby - Feature #16431: Optionally load did_you_mean (and RubyGems) Closed

History

#1 - 11/24/2019 03:09 AM - shevegen (Robert A. Heiler)

\o/

(^^^ That's an upvote emoji really.)

#2 - 11/28/2019 07:01 AM - matz (Yukihiro Matsumoto)

Accepted. Go ahead.

Matz.

#3 - 12/06/2019 01:26 PM - vo.x (Vit Ondruch)

I think we should go rather in opposite direction. Move all gems to "bundled" gems. Especially "did_you_mean" gem does not provide any benefit to 

end user of application and it should not be used in runtime. It is just perfectly fine when its functionality is optional.

BTW since the PR was merged, this ticket should have been closed.

#4 - 12/06/2019 03:54 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Closed

#5 - 12/09/2019 01:15 AM - hsbt (Hiroshi SHIBATA)

- Tracker changed from Bug to Feature

- Assignee set to yuki24 (Yuki Nishijima)

- Backport deleted (2.5: UNKNOWN, 2.6: UNKNOWN)

#6 - 12/17/2019 12:17 PM - vo.x (Vit Ondruch)

- Related to Bug #16427: Revert did_you_mean promotion to default gem. added

#7 - 12/18/2019 02:20 PM - vo.x (Vit Ondruch)

- Related to Feature #16431: Optionally load did_you_mean (and RubyGems) added
https://github.com/ruby/ruby/blob/fb6a489af2765a3b56e301adf0019af6bbad6156/lib/optparse.rb#L1792
https://github.com/ruby/rake/blob/985abffa9954d21790831d9626d9c38b24a94199/lib/rake/task_manager.rb#L69-L78
https://github.com/rails/rails/blob/98a57aa5f610bc66af31af409c72173cdeeb3c9e/railties/lib/rails/command/spellchecker.rb#L8
https://github.com/yuki24/did_you_mean/issues/117#issuecomment-482733159
